

#include <stdlib.h>
#include <avr/io.h>
#include "lcdlib.h"
#include <avr/power.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "tsic.h"


#define F_CPU 1000000UL		//1MHz

//====== Konstanten und Variablen =============
uint16_t adcval = 0;
uint8_t z = 0;
const uint8_t grad[8] = {0b00110,0b01001,0b01001,0b00110,0b00000,0b00000,0b00000,0b00000};	//degree character

//====== Deklarationen ===================
void initiateall(void);
void deactivate_io(void);
uint16_t ADC_Read(void);
uint16_t ADC_Read_Avg(uint8_t average);
void read_spannung(void);
void read_tsic(void);

/*
struct
{
	unsigned c:1;
	unsigned n:1;
}v;

ISR(PCINT1_vect) {
	PCMSK1 = 0x00;
	//GIMSK = 0x00;
	//	x.tast = 1;
	reti();
}
*/

int main(void)
{
	initiateall();
    
	while(1)
    {
		read_spannung();
		read_tsic();
	}
	return 0;
} // END



///////////////////////////INITIATE///////////////////////////

void initiateall(void)
{
	//DDRB |= (1<<PB1);
	//PORTB |= (1<<PB0);
	ADMUX |= (1<<REFS0) | (1<<REFS1) | (1<<MUX0) | (1<<MUX2);
	ADCSRA |= (1<<ADEN) | (1<<ADPS1);

	TSIC_INIT();
	lcd_init();
	lcd_setcursor(0,1);
	lcd_string("U=");					// 1. Zeile Spannung =
	lcd_setcursor(0,2);
	lcd_string("T=");					// 2. Zeile Temp = 
	lcd_setcursor(7,1);
	lcd_data('V');
	lcd_generatechar(z,grad);
	lcd_setcursor(7,2);
	lcd_data(z);
	
}


///////////////////////////ADC/////////////////////////////////
uint16_t ADC_Read_Avg(uint8_t average)
{
	uint32_t result = 0;
	for (uint8_t i = 0; i < average; ++i )
	result += ADC_Read();
	return (uint16_t)( result / average );
}

uint16_t ADC_Read(void)
{
	ADCSRA |= (1<<ADSC);
while (ADCSRA & (1<<ADSC) ) {}
	return ADCW;

}

void read_spannung(void)
{
	char y[10];
	double Spannung = 0;
	adcval = ADC_Read_Avg(100);
	Spannung = (1.1 / 1024) * adcval * 17.9;
	dtostrf(Spannung,4,1,y);
	lcd_setcursor(3,1);
	lcd_string(y);
}
///////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////
void read_tsic(void)
{
	char x[10];
	uint16_t temperatur;  // 11-bit temperature value
	uint8_t returnvalue;  // return value of getTSicTemp(*temp);
	double Temp_celsius; // converted temperature in °C
	
	returnvalue = getTSicTemp(&temperatur);
	Temp_celsius = ((float)temperatur / 2047 * 200) - 50;		//(temperatur * 0.097704) -50;
	dtostrf(Temp_celsius,5,1,x);
	lcd_setcursor(2,2);
	lcd_string(x);
}
