
#include <avr/io.h>

#ifndef TSIC_H_
#define TSIC_H_

#ifndef F_CPU
#define F_CPU 8000000UL
#endif 
/******************************************************************************
* Hardware Connection of the TSIC-Sensor
******************************************************************************/

#define TSIC_PORT             PORTC  // Port to use
#define TSIC_PIN              PINC
#define TSIC_PORT_DDR         DDRC
#define TSCI_POWER_PIN        PC3    // Where TSIC-Sensors VCC is connected
#define TSIC_SIGNAL_PIN       PC2    // Where TSIC-Sensors "Signal"-Pin is con.


/******************************************************************************
* FUNCTION MACROS
******************************************************************************/

// Define TSCI_POWER_PIN as output, TSIC_SIGNAL_PIN as input
#define TSIC_INIT()           { TSIC_PORT_DDR |= (1<<TSCI_POWER_PIN); \
                              TSIC_PORT_DDR &= ~(1<<TSIC_SIGNAL_PIN); }

// Power up the TSIC-Sensor
#define TSIC_ON()             TSIC_PORT |=  (1<<TSCI_POWER_PIN)

// Power down the TSIC-Sensor
#define TSIC_OFF()            TSIC_PORT &= ~(1<<TSCI_POWER_PIN)

//#define TSIC_SIGNAL           (TSIC_PORT &   (1<<TSIC_SIGNAL_PIN))

// Low/High Signal of the TSIC-Sensor, e.g. "if(TSIC_SIGNAL_HIGH)..."
#define TSIC_SIGNAL_HIGH      TSIC_PIN & ( 1 << TSIC_SIGNAL_PIN )
#define TSIC_SIGNAL_LOW       !( TSIC_PIN & ( 1 << TSIC_SIGNAL_PIN ))



volatile uint8_t getTSicTemp (uint16_t *temp_value16);



#endif /* TSIC_H_ */