
#include "u8g.h"
#include "Tsic.h"
#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

u8g_t u8g;
uint16_t adcval = 0;
char s[10];
char t[12];

uint16_t ADC_Read(void);
uint16_t ADC_Read_Avg(uint8_t average);
void read_spannung(void);
volatile void read_tsic(void);

void u8g_setup(void)
{
	ADMUX |= (1<<REFS0) | (1<<REFS1) | (1<<MUX2);
	ADCSRA |= (1<<ADEN) | (1<<ADPS1) | (1<<ADPS2);
	TSIC_INIT();
//u8g_SetPinInput(PN(2,5)); u8g_SetPinLevel(PN(2,5), 1); u8g_SetPinOutput(PN(2,5));
//u8g_SetPinInput(PN(2,4)); u8g_SetPinLevel(PN(2,4), 1); u8g_SetPinOutput(PN(2,4));
u8g_SetPinInput(PN(2,4));
u8g_SetPinOutput(PN(1,5));u8g_SetPinOutput(PN(1,3));u8g_SetPinOutput(PN(1,2));u8g_SetPinOutput(PN(1,1));u8g_SetPinOutput(PN(1,0));
u8g_InitSPI(&u8g, &u8g_dev_ssd1306_128x64_hw_spi, PN(1, 5), PN(1, 3), PN(1, 2), PN(1, 1), PN(1,0));			//

u8g_SetColorIndex(&u8g, 1);
u8g_SetFont(&u8g, u8g_font_8x13);
}

void draw(void)
{
//	if (icewarning)
//	{
//		u8g_SetCursorFont(&u8g,);
//		u8g_SetCursorStyle(&u8g,);
//		u8g_SetCursorPos(&u8g,);
//	}
//	u8g_SetFont(&u8g, u8g_font_7x14);
//	u8g_DrawBox(&u8g, 10, 12, 20, 38);
//	u8g_DrawStr(&u8g, 30, 20, x);
//	u8g_SetColorIndex(&u8g, 0);
//	u8g_DrawPixel(&u8g, 28, 14);
//	u8g_DrawStr(&u8g, 20, 14, "Working");
//	u8g_DrawStr(&u8g, 20, 30, "now!");
	
//	u8g_DrawLine(&u8g, 0, 0, 127, 31);
//	u8g_DrawLine(&u8g, 0, 31, 127, 0);
}


int main(void)
{
	u8g_setup();
	
   for(;;)
    {
	   read_spannung();
	   read_tsic();
       u8g_FirstPage(&u8g);
	   
       do
       {
		   u8g_DrawStr(&u8g, 20, 40, "T=");		
		   u8g_DrawStr(&u8g, 20, 20, "U=");
		   u8g_DrawStr(&u8g, 40, 40, t);	//Draw temperature value
		   u8g_DrawStr(&u8g, 40, 20, s);	//Draw Voltage value
		   //u8g_DrawStr(&u8g, 40,60,temperatur);
		   u8g_DrawFrame(&u8g,0,0,127,63);
		 //  draw();
       } 
	   while (u8g_NextPage(&u8g));
	} 
} 


///////////////////////////////////////////////////////////////

///////////////// Voltage Readout//////////////////////////////

void read_spannung(void)
{
	double Spannung = 0;
	adcval = ADC_Read_Avg(100);									//Average of/after 100 measurements in a row
	Spannung = (1.1 / 1024) * adcval * 17.9;					//Hardware specific - 17,9 is my voltage divider ratio (to measure voltages till ~20V - internal 1,1V Vref) -70V -won't exceed 5V - Car safe. Tested (petrol).
	dtostrf(Spannung,4,1,s);									//convert double to string, 4 in length (with - & .) display 1 digit after comma, from val. s (voltage)
//	lcd_string(y);
}

uint16_t ADC_Read_Avg(uint8_t average)
{
	uint32_t result = 0;
	for (uint8_t i = 0; i < average; ++i )
	result += ADC_Read();
	return (uint16_t)( result / average );
}

uint16_t ADC_Read(void)
{
	ADCSRA |= (1<<ADSC);
while (ADCSRA & (1<<ADSC) ) {}
return ADCW;

}

///////////////////////////////////////////////////////////////

///////////////// Temperature Readout//////////////////////////

volatile void read_tsic(void)
{
	uint16_t temperatur;										// 11-bit temperature value
	uint8_t returnvalue;										// return value of getTSicTemp(*temp);
	double Temp_celsius;										// converted temperature in C
	returnvalue = getTSicTemp(&temperatur);						// invoke temperature readout
	Temp_celsius = ((float)temperatur / 2047.0 * 200.0) - 50.0;		// (temperatur * 0.097704) -50; calculate temperature value from 11-Bit temperature information
	//Temp_celsius = ((float)temperatur * 0.097704) -50;
	//itoa(Temp_celsius,t,10);
	dtostrf(Temp_celsius,6,1,t);								//convert double to string, 5 in length (with - & .) display 1 digit after comma, from val. t (temperature)
}